<?php
function ma_get_default_options() {
	$options = array(
		'logo' => ''
	);
	return $options;
}

function ma_options_init() {
     $ma_options = get_option( 'theme_ma_options' );
	 
     if ( false === $ma_options ) {
          $ma_options = ma_get_default_options();
		  add_option( 'theme_ma_options', $ma_options );
     }
}

// Initialize Theme options
add_action( 'after_setup_theme', 'ma_options_init' );

function ma_options_setup() {
	global $pagenow;
	if ('media-upload.php' == $pagenow || 'async-upload.php' == $pagenow) {
		add_filter( 'gettext', 'replace_thickbox_text' , 1, 2 );
	}
}
add_action( 'admin_init', 'ma_options_setup' );

function replace_thickbox_text($translated_text, $text ) {	
	if ( 'Insert into Post' == $text ) {
		$referer = strpos( wp_get_referer(), 'ma-settings' );
		if ( $referer != '' ) {
			return __('I want this to be my logo!', 'ma' );
		}
	}

	return $translated_text;
}

// Add "Elisium Logo Options" link to the "Appearance" menu
function ma_menu_options() {
	//add_theme_page( $page_title, $menu_title, $capability, $menu_slug, $function);
     add_theme_page(' Change Logo', 'Change Logo', 'edit_theme_options', 'ma-settings', 'ma_admin_options_page');
}
// Load the Admin Options page
add_action('admin_menu', 'ma_menu_options');

function ma_admin_options_page() {
	?>
		
		<div class="wrap">
			
			<div id="icon-themes" class="icon32"><br /></div>
		
			
			
			<!-- If we have any error by submiting the form, they will appear here -->
			<?php settings_errors( 'ma-settings-errors' ); ?>
			
			<form id="form-options" action="options.php" method="post" enctype="multipart/form-data">
			
				<?php
					settings_fields('theme_ma_options');
					do_settings_sections('ma');
				?>
			
				<p class="submit">
					<input name="theme_ma_options[submit]" id="submit_options_form" type="submit" class="button-primary" value="<?php esc_attr_e('Save Settings', 'ma'); ?>" />
					<input name="theme_ma_options[reset]" type="submit" class="button-secondary" value="<?php esc_attr_e('Reset Defaults', 'ma'); ?>" />		
				</p>
			
			</form>
			
		</div>
	<?php
}

function ma_options_validate( $input ) {
	$default_options = ma_get_default_options();
	$valid_input = $default_options;
	
	$ma_options = get_option('theme_ma_options');
	
	$submit = ! empty($input['submit']) ? true : false;
	$reset = ! empty($input['reset']) ? true : false;
	$delete_logo = ! empty($input['delete_logo']) ? true : false;
	
	if ( $submit ) {
		if ( $ma_options['logo'] != $input['logo']  && $ma_options['logo'] != '' )
			delete_image( $ma_options['logo'] );
		
		$valid_input['logo'] = $input['logo'];
	}
	elseif ( $reset ) {
		delete_image( $ma_options['logo'] );
		$valid_input['logo'] = $default_options['logo'];
	}
	elseif ( $delete_logo ) {
		delete_image( $ma_options['logo'] );
		$valid_input['logo'] = '';
	}
	
	return $valid_input;
}

function delete_image( $image_url ) {
	global $wpdb;
	
	// We need to get the image's meta ID..
	$query = "SELECT ID FROM wp_posts where guid = '" . esc_url($image_url) . "' AND post_type = 'attachment'";  
	$results = $wpdb -> get_results($query);

	// And delete them (if more than one attachment is in the Library
	foreach ( $results as $row ) {
		wp_delete_attachment( $row -> ID );
	}	
}

/********************* JAVASCRIPT ******************************/
function ma_options_enqueue_scripts() {
	wp_register_script( 'upload', get_template_directory_uri() .'/options/upload.js', array('jquery','media-upload','thickbox') );	

	if ( 'appearance_page_ma-settings' == get_current_screen() -> id ) {
		wp_enqueue_script('jquery');
		
		wp_enqueue_script('thickbox');
		wp_enqueue_style('thickbox');
		
		wp_enqueue_script('media-upload');
		wp_enqueue_script('upload');
		
	}
	
}
add_action('admin_enqueue_scripts', 'ma_options_enqueue_scripts');


function ma_options_settings_init() {
	register_setting( 'theme_ma_options', 'theme_ma_options', 'ma_options_validate' );
	
	// Add a form section for the Logo
	add_settings_section('ma_settings_header', __( 'Logo Options', 'ma' ), 'ma_settings_header_text', 'ma');
	
	// Add Logo uploader
	add_settings_field('ma_setting_logo',  __( 'Logo', 'ma' ), 'ma_setting_logo', 'ma', 'ma_settings_header');
	
	// Add Current Image Preview 
	add_settings_field('ma_setting_logo_preview',  __( 'Logo Preview', 'ma' ), 'ma_setting_logo_preview', 'ma', 'ma_settings_header');
}
add_action( 'admin_init', 'ma_options_settings_init' );

function ma_setting_logo_preview() {
	$ma_options = get_option( 'theme_ma_options' );  ?>
	<div id="upload_logo_preview" style="min-height: 100px;">
		<img style="max-width:100%;" src="<?php echo esc_url( $ma_options['logo'] ); ?>" />
	</div>
	<?php
}

function ma_settings_header_text() {
	?>
		<p><?php _e( 'Manage Logo Options for Fresh Look.', 'ma' ); ?></p>
	<?php
}

function ma_setting_logo() {
	$ma_options = get_option( 'theme_ma_options' );
	?>
		<input type="hidden" id="logo_url" name="theme_ma_options[logo]" value="<?php echo esc_url( $ma_options['logo'] ); ?>" />
		<input id="upload_logo_button" type="button" class="button" value="<?php _e( 'Upload Logo', 'ma' ); ?>" />
		<?php if ( '' != $ma_options['logo'] ): ?>
			<input id="delete_logo_button" name="theme_ma_options[delete_logo]" type="submit" class="button" value="<?php _e( 'Delete Logo', 'ma' ); ?>" />
		<?php endif; ?>
		<span class="description"><?php _e('Upload an image for the company logo.', 'ma' ); ?></span>
	<?php
}

?>